{
  Solutions to the Advent Of Code.
  Copyright (C) 2023-2024  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UCommon;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Generics.Collections;

type
  PPoint = ^TPoint;

const
  CNoDirection: TPoint = (X: 0; Y: 0);
  CDirectionRight: TPoint = (X: 1; Y: 0);
  CDirectionDown: TPoint = (X: 0; Y: 1);
  CDirectionLeft: TPoint = (X: -1; Y: 0);
  CDirectionUp: TPoint = (X: 0; Y: -1);
  CDirectionRightDown: TPoint = (X: 1; Y: 1);
  CDirectionRightUp: TPoint = (X: 1; Y: -1);
  CDirectionLeftDown: TPoint = (X: -1; Y: 1);
  CDirectionLeftUp: TPoint = (X: -1; Y: -1);
  CPCardinalDirections: array[0..3] of PPoint = (@CDirectionRight, @CDirectionDown, @CDirectionLeft, @CDirectionUp);

type
  TIntegerList = specialize TList<Integer>;

implementation

end.

